#include <iostream>
#include <locale>
#include <regex>
using namespace std;

int main( int argc, char *argv[] ) {
   locale::global( locale ( "ru_RU.utf8" ) );
   wstring buf = L"Строка строка строка";
   wstring wp = L"строка";
   if( argc > 1 ) {
      wchar_t warg[ strlen( argv[ 1 ] ) + 1 ];
      mbstowcs( warg, argv[ 1 ], strlen( argv[ 1 ] ) + 1 );
      wp = wstring( warg );
   }
   basic_regex<wchar_t> pattern( wp );     // образец      
   basic_regex<wchar_t> pattern( wp, regex_constants::icase | regex_constants::awk );
   wcmatch match;                          // результат сопоставления
   while( wcin >> buf ) {
      wcout << L'\'' << buf << L"' ->" << endl;
      if( !regex_search( (wchar_t*)buf.c_str(), match, pattern ) ) {
//      if( !regex_match( (wchar_t*)buf.c_str(), match, pattern ) ) {
         wcout << "no match" << endl;
         continue;
      }
      for( auto &m: match ) wcout << ": " <<m << endl;
   }
}

